=== added directory 'gatekeeper'
=== added file 'gatekeeper/README.md'
--- gatekeeper/README.md	1970-01-01 00:00:00 +0000
+++ gatekeeper/README.md	2014-04-25 12:34:29 +0000
@@ -0,0 +1,219 @@
+UCI-Airline Gatekeeper
+======================
+
+
+Setup
+-----
+
+Create a virtualenv and install the system requirements::
+
+  $ virtualenv env
+  ...
+  $ ./env/bin/activate
+  (env)$ pip install -r requirements.txt
+  ...
+
+Then you can run *sandbox.py*::
+
+  (env)$ ./sandbox.py -h
+  Usage: sandbox.py [options] [args]
+
+  Options:
+    -v, --verbose
+    -A AUTH_URL, --auth-url=AUTH_URL
+    -U USERNAME, --username=USERNAME
+    -K PASSWORD, --key=PASSWORD
+    -T TENANT, --tenant=TENANT
+    -R REGION, --region=REGION
+    -V API_VERSION, --api-version=API_VERSION
+    --hp-tenant-id=TENANT_ID
+    --hp-access-key-id=ACCESS_KEY_ID
+    --hp-secret-key=SECRET_KEY
+    -h, --help            show this help message and exit
+
+Or run a local REST wsgi server::
+
+  (env)$ python gatekeeper.py
+  Running server on port 8080...
+  ...
+
+and use its API::
+
+  $ curl http://localhost:8080/api/v1/
+  CI-Airline gatekeeper.
+
+
+Testing
+-------
+
+Inside the vitualenv, tests can be run with::
+
+  (env)$ python -munittest discover
+  ...
+
+
+REST API Usage
+--------------
+
+Server greeting message::
+
+  (env)$ curl http://localhost:8080/api/v1/
+  CI-Airline gatekeeper.
+
+Creating a sandbox (note the 'Location' header)::
+
+  (env)$ curl -i -X POST http://localhost:8080/api/v1/
+  HTTP/1.0 201 Created
+  ...
+  Content-Type: text/plain
+  Location: /api/v1/2aca8376-cb6f-11e3-a385-001c4229f9ac
+  Content-Length: 44
+
+  /api/v1/2aca8376-cb6f-11e3-a385-001c4229f9ac
+
+Uploading objects to the sandbox::
+
+  (env)$ curl -X PUT http://localhost:8080/api/v1/sandbox/\
+  2aca8376-cb6f-11e3-a385-001c4229f9ac/README.md | xargs curl -X PUT \
+  --header "Content-Type: application/octet-stream" \
+  --data-binary "@README.md"
+  ...
+
+Listing sandbox objects::
+
+  (env)$ curl http://localhost:8080/api/v1/sandbox/\
+  2aca8376-cb6f-11e3-a385-001c4229f9ac
+  README.md (5661 bytes, application/octet-stream)
+
+Downloading sandbox objects::
+
+  (env)$ curl -X GET http://localhost:8080/api/v1/sandbox/\
+  2aca8376-cb6f-11e3-a385-001c4229f9ac/README.md | xargs curl
+  ...
+
+Finally dropping the sandbox and its contents::
+
+  (env)$ curl -X DELETE http://localhost:8080/api/v1/sandbox/\
+  2aca8376-cb6f-11e3-a385-001c4229f9ac
+
+
+Script Usage
+------------
+
+Using environment canonistack variables (OS_*)::
+
+  (env)$ . ~/.canonistack/novarc
+
+Create a new sandbox in cannonistask::
+
+  (env)$ ./sandbox.py create
+
+  Sandbox created: 5bf928ba-cb12-11e3-bfe4-001c4229f9ac
+
+Listing existing sandboxes in canonistack::
+
+  (env)$ ./sandbox.py list
+
+  All Sandboxes:
+          5bf928ba-cb12-11e3-bfe4-001c4229f9ac (0 bytes, 0 objects)
+
+Listing existing sandboxes on the local swift instance::
+
+  (env)$ ./sandbox.py -A http://10.0.3.64:8080/auth/v1.0 \
+  -U testproj:testuser -K testpwd -V1 list
+
+  All Sandboxes:
+          02c5fc18-ca73-11e3-88d9-001c4229f9ac (1912 bytes, 1 objects)
+	  b6316856-ca5e-11e3-889c-001c4229f9ac (7871 bytes, 2 objects)
+
+Listing sandbox contents on the local swift::
+
+  (env)$ ./sandbox.py -A http://10.0.3.64:8080/auth/v1.0 \
+  -U testproj:testuser -K testpwd -V1 \
+  list 02c5fc18-ca73-11e3-88d9-001c4229f9ac
+
+  02c5fc18-ca73-11e3-88d9-001c4229f9ac (1912 bytes, 1 objects)
+          setup-swift.sh (1912 bytes, text/x-sh)
+
+Downloading objects using tempurl::
+
+  (env)$ ./sandbox.py -A http://10.0.3.64:8080/auth/v1.0 \
+  -U testproj:testuser -K testpwd -V1 \
+  download 02c5fc18-ca73-11e3-88d9-001c4229f9ac setup-swift.sh
+
+  Downloading from http://10.0.3.64:8080/v1/AUTH_testproj/\
+  sandbox-02c5fc18-ca73-11e3-88d9-001c4229f9ac/setup-swift.sh?\
+  temp_url_sig=a67bb00622365b1f7455e1bc3c0fc1729bb3eef4&\
+  temp_url_expires=1398276831
+
+Uploading objects using tempurl::
+
+  (env)$ ./sandbox.py -A http://10.0.3.64:8080/auth/v1.0 \
+  -U testproj:testuser -K testpwd -V1 \
+  upload 02c5fc18-ca73-11e3-88d9-001c4229f9ac setup-swift.sh
+
+  Uploading to http://10.0.3.64:8080/v1/AUTH_testproj/\
+  sandbox-02c5fc18-ca73-11e3-88d9-001c4229f9ac/setup-swift.sh?\
+  temp_url_sig=115e4e68a75f0845e42d1f68d4e0f4ec97a269d0&\
+  temp_url_expires=1398276895
+
+Drop an existing sandbox::
+
+  (env)$ ./sandbox.py -A http://10.0.3.64:8080/auth/v1.0 \
+  -U testproj:testuser -K testpwd -V1 \
+  drop e2175b00-cb13-11e3-b370-001c4229f9ac
+
+  Sandbox dropped: e2175b00-cb13-11e3-b370-001c4229f9ac
+
+HP cloud uses a slightly different signature `schema
+<http://docs.hpcloud.com/api/object-storage#temp_url-jumplink-span>`.
+The main issue, when compared to usual openstack deployments, is that
+it prepends 'tenant_id' and 'access_key_id' to the SHA1 signature and
+also uses the account global secret_key, instead of user-created one,
+to create tempurls signatures.
+
+Once you find out all this HP-specific parameters (check Horizon accounts
+UI), they can be passed to script via the '--hp-*' options::
+
+  (env)$ ./sandbox.py \
+  -A https://region-a.geo-1.identity.hpcloudsvc.com:35357/v2.0/ \
+  -U cprov@canonical.com -K '<PASS>' -T celso_project -R 'region-a.geo-1' \
+  --hp-tenant-id 11922491647292 \
+  --hp-access-key-id YZXTZCND7S8B2527GJJ4 \
+  --hp-secret-key <SECRET> \
+  list
+  All Sandboxes:
+          4bfdd05e-cb13-11e3-9db0-001c4229f9ac (0 bytes, 0 objects)
+
+
+Local Swift Setup
+-----------------
+
+We can use a script to setup an LXC container with basic (read totally
+insecure) authentication and tempurl module enabled for tests::
+
+  $ sudo apt-get install lxc
+  $ sudo lxc-create -n swift -t ubuntu -- -r trusty
+  $ sudo lxc-start -d -n swift
+
+Find out the LXC IP address::
+
+  $ sudo lxc-ls --fancy
+  [sudo] password for cprov:
+  NAME   STATE    IPV4       IPV6  AUTOSTART
+  ------------------------------------------
+  swift  RUNNING  10.0.3.64  -     NO
+
+Log in the LXC (pass: ubuntu)::
+
+  $ scp setup-swift.sh ubuntu@10.0.3.64:
+  ...
+  $ ssh ubuntu@10.0.3.64
+  ...
+  ubuntu@swift:~$ sudo ./setup-swift.sh
+  ...
+
+Back on the host machine, use the swift client::
+
+  (env)$ swift -A http://10.0.3.134:8080/auth/v1.0 -U testproj:testuser \
+  -K testpwd stat

=== added directory 'gatekeeper/gatekeeper'
=== added file 'gatekeeper/gatekeeper-app.py'
--- gatekeeper/gatekeeper-app.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper-app.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,49 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+"""Gatekeeper WSGI server.
+
+Exposes Swift "Sandbox" (supervised container + tempurls) funtionality
+via a REST API.
+"""
+from __future__ import unicode_literals
+
+import argparse
+import logging
+from wsgiref.simple_server import make_server
+
+from gatekeeper.datastore import DataStore
+from gatekeeper.datastore.options import DataStoreOptions
+from gatekeeper.resources.root import make_app
+
+
+def local_datastore_factory(klass):
+    options = DataStoreOptions(
+        auth_url='http://10.0.3.64:8080/auth/v1.0',
+        username='testproj:testuser',
+        password='testpwd',
+        version='1')
+    return DataStore(options)
+
+
+def run_server():
+    parser = argparse.ArgumentParser(
+        description='Run webservice in python\'s wsgi reference server.')
+    parser.add_argument('-p', '--port', type=int, default=8080,
+                        help='Port to use. Default=%(default)d')
+    args = parser.parse_args()
+
+    logging.basicConfig(level=logging.DEBUG)
+
+    wsgi_app = make_app(local_datastore_factory)
+
+    httpd = make_server('', args.port, wsgi_app)
+    try:
+        print('Running server on port %d...' % args.port)
+        httpd.serve_forever()
+    except KeyboardInterrupt:
+        print('exiting')
+        pass
+
+
+if __name__ == '__main__':
+    run_server()

=== added file 'gatekeeper/gatekeeper/__init__.py'
--- gatekeeper/gatekeeper/__init__.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/__init__.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,2 @@
+# -*- coding: utf-8 -*-
+"""UCI-Airline Gatekeeper module."""

=== added directory 'gatekeeper/gatekeeper/datastore'
=== added file 'gatekeeper/gatekeeper/datastore/__init__.py'
--- gatekeeper/gatekeeper/datastore/__init__.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/__init__.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,9 @@
+# -*- coding: utf-8 -*-
+"""Swift datastore module."""
+
+from base import BasicDataStore
+from sandbox import SupervisedSandboxesMixin
+
+
+class DataStore(SupervisedSandboxesMixin, BasicDataStore):
+    """Swift data store utility."""

=== added file 'gatekeeper/gatekeeper/datastore/base.py'
--- gatekeeper/gatekeeper/datastore/base.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/base.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,32 @@
+# -*- coding: utf-8 -*-
+"""Swift datastore base classes."""
+from __future__ import unicode_literals
+
+from swiftclient import client
+
+
+class BasicDataStore(object):
+    """Swift basic data store utility."""
+
+    def __init__(self, options):
+        """Immediately retrieve and store Swift authenticated URL."""
+        self.options = options
+        self._setup_auth()
+
+    def _setup_auth(self):
+        if self.options.api_version == '1':
+            self.url, self.token = client.get_auth_1_0(
+                self.options.auth_url,
+                self.options.username,
+                self.options.password,
+                False,
+            )
+            return
+        self.url, self.token = client.get_auth(
+            self.options.auth_url,
+            self.options.username,
+            self.options.password,
+            tenant_name=self.options.tenant,
+            os_options={'region_name': self.options.region},
+            auth_version=self.options.api_version,
+        )

=== added file 'gatekeeper/gatekeeper/datastore/options.py'
--- gatekeeper/gatekeeper/datastore/options.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/options.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,20 @@
+# -*- coding: utf-8 -*-
+"""Swift Sandbox datastore options."""
+from __future__ import unicode_literals
+
+import os
+
+
+class DataStoreOptions(object):
+    """Swift datastore options builder."""
+
+    def __init__(self, **kwargs):
+        self.auth_url = kwargs.get('auth_url', os.environ.get('OS_AUTH_URL'))
+        self.username = kwargs.get('username', os.environ.get('OS_USERNAME'))
+        self.password = kwargs.get('password', os.environ.get('OS_PASSWORD'))
+        self.tenant = kwargs.get('tenant', os.environ.get('OS_TENANT_NAME'))
+        self.region = kwargs.get('region', os.environ.get('OS_REGION_NAME'))
+        self.api_version = kwargs.get('version', '2')
+        self.access_key_id = kwargs.get('access_key_id')
+        self.tenant_id = kwargs.get('tenant_id')
+        self.secret_key = kwargs.get('secret_key')

=== added file 'gatekeeper/gatekeeper/datastore/sandbox.py'
--- gatekeeper/gatekeeper/datastore/sandbox.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/sandbox.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,150 @@
+# -*- coding: utf-8 -*-
+"""Swift supervised sandboxes mixin."""
+from __future__ import unicode_literals
+
+import datetime
+import uuid
+
+from swiftclient import client
+
+from tempurl import (
+    OSTempUrlProvider,
+    HPTempUrlProvider,
+    )
+
+
+class SandboxObject(object):
+    """Swift sandbox object."""
+
+    def __init__(self, **kwargs):
+        self.name = kwargs.get('name')
+        self.size = kwargs.get('bytes')
+        self.ctype = kwargs.get('content_type')
+
+    def __unicode__(self):
+        return self.title
+
+    @property
+    def title(self):
+        return '{} ({} bytes, {})'.format(self.name, self.size, self.ctype)
+
+
+class SandboxContainer(object):
+    """Swift sandbox utility with tempurl support. """
+
+    PREFIX = 'sandbox-'
+
+    def __init__(self, url, token, options, **kwargs):
+        self.url = url
+        self.token = token
+        self.options = options
+        self.name = kwargs.get('name')
+        self.size = kwargs.get('bytes')
+        self.count = kwargs.get('count')
+
+    def __unicode__(self):
+        return self.title
+
+    @property
+    def identifier(self):
+        """Return the UUIDv1 part of the sandbox container name."""
+        return self.name.replace(self.PREFIX, '')
+
+    @property
+    def title(self):
+        """Return a text line describing this sandbox."""
+        return '{} ({} bytes, {} objects)'.format(
+            self.identifier, self.size, self.count)
+
+    def _now(self):
+        """Local wrapper for datetime.now() for facilitating tests."""
+        return datetime.datetime.now() 
+
+    @property
+    def age(self):
+        """Returns the age of this sandbox based on its name.
+
+        Calculates the age of this sandbox based on the UUIDv1 used
+        as its identifier.
+
+        param: return: TimeDelta corresponding to this sandbox age.
+        """
+        u = uuid.UUID(self.identifier)
+        assert u.version == 1, 'Only UUIDv1 is supportted'
+        uuid_timestamp = (u.time - 0x01b21dd213814000L) / 1e7 
+        created = datetime.datetime.fromtimestamp(uuid_timestamp)
+        return self._now() - created
+
+    @property
+    def objects(self):
+        """Iterator of `SandboxObjects` within this sandbox."""
+        header, contents = client.get_container(
+            self.url, self.token, self.name)
+        return [SandboxObject(**c) for c in contents]
+
+    def drop(self):
+        """Remove the sandbox and its contents."""
+        for obj in self.objects:
+            client.delete_object(self.url, self.token, self.name, obj.name)
+        client.delete_container(self.url, self.token, self.name)
+
+    def _get_tempurl_key(self):
+        """Local wrapper to UUID for facilitating tests."""
+        return str(uuid.uuid1())
+
+    def _get_tempurl_provider(self):
+        """Return the tempurl provider appropriate for this context."""
+        if 'hpcloud' in self.options.auth_url:
+            return HPTempUrlProvider(self.url, self.token, self.options)
+        return OSTempUrlProvider(self.url, self.token, self.options)
+
+    def get_temp_url(self, object_name, method='GET'):
+        """Return a tempurl for the given object_name and method."""
+        provider = self._get_tempurl_provider()
+        provider.set_temp_key(self._get_tempurl_key())
+        return provider.get_temp_url(self.name, object_name, method=method)
+
+
+class SupervisedSandboxesMixin(object):
+    """Swift datastore mixin for supervised sandboxes utility."""
+
+    def _get_container_name(self, identifier):
+        """Return the container name for a given sandbox identifier."""
+        return SandboxContainer.PREFIX + identifier
+
+    def _get_sandboxes(self, name=None):
+        """Iterator of existing sandboxes as `SandboxContainer`s.
+
+        If name is given, user it to filter the list.
+        """
+        if name is None:
+            prefix = SandboxContainer.PREFIX
+        else:
+            prefix = name
+        header, contents = client.get_account(
+            self.url, self.token, prefix=prefix)
+        return [SandboxContainer(self.url, self.token, self.options, **c)
+                for c in contents]
+
+    @property
+    def sandboxes(self):
+        """Iterator on all existing `SandboxContainer`s."""
+        return self._get_sandboxes()
+
+    def get_sandbox(self, identifier):
+        """Return an specific `SandboxContainer`."""
+        container_name = self._get_container_name(identifier)
+        sandboxes = list(self._get_sandboxes(name=container_name))
+        assert len(sandboxes) == 1, 'No single sandbox found.'
+        return sandboxes[0]
+
+    def _get_sandbox_identifier(self):
+        """Local wrapper to UUID for facilitating tests."""
+        return str(uuid.uuid1())
+
+    def create_sandbox(self):
+        """Create a new `SandboxContainer`."""
+        identifier = self._get_sandbox_identifier()
+        container_name = self._get_container_name(identifier)
+        client.put_container(self.url, self.token, container_name)
+        return self.get_sandbox(identifier)

=== added file 'gatekeeper/gatekeeper/datastore/tempurl.py'
--- gatekeeper/gatekeeper/datastore/tempurl.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/tempurl.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,80 @@
+# -*- coding: utf-8 -*-
+"""Datastore TempURL provider classes"""
+from __future__ import unicode_literals
+
+import hashlib
+import hmac
+import os
+import time
+
+from swiftclient import client
+
+
+class OSTempUrlProvider(object):
+    """OpenStack tempurl provider."""
+
+    def __init__(self, url, token, options):
+        """Manage local 'temp_key' and 'options' values."""
+        self.url = url
+        self.token = token
+        self.options = options
+        self.temp_key = None
+
+    def set_temp_key(self, key):
+        """Set a temporary key for this context.
+
+        Sets 'X-Account-Meta-Temp-URL-Key'.
+        """
+        assert isinstance(key, bytes), "Key must be string/bytes"
+        temp_key_headers = {
+            'X-Account-Meta-Temp-URL-Key': key,
+        }
+        client.post_account(self.url, self.token, temp_key_headers)
+        self.temp_key = key
+
+    def _get_path(self, container, object_name):
+        auth_url = self.url.split('/')[-1]
+        return '/v1/{}/{}/{}'.format(auth_url, container, object_name)
+
+    def _get_temp_signature(self, method, expires, path):
+        assert self.temp_key is not None, 'TempKey is not set'
+        body = '%s\n%s\n%s' % (method, expires, path)
+        return hmac.new(self.temp_key, body, hashlib.sha1).hexdigest()
+
+    def get_temp_url(self, container, object_name, expires=60,
+                     method='GET'):
+        """Assembly a Swift tempurl for the given object path.
+
+        It allow access from unauthenticated clients.
+        """
+        host = '/'.join(self.url.split('/')[:3])
+        path = self._get_path(container, object_name)
+        expires = int(time.time() + expires)
+        sig = self._get_temp_signature(method, expires, path)
+        url = '{host}{path}?temp_url_sig={sig}&temp_url_expires={expires}'
+        return url.format(host=host, path=path, sig=sig,
+                          expires=expires)
+
+
+class HPTempUrlProvider(OSTempUrlProvider):
+    """HP tempurl provider."""
+
+    def set_temp_key(self, key):
+        """HP smartly reuses the secret key for signing tempurls.
+
+        It means the manager can't simply refresh the tempurl key to
+        invalidate old tempurls without causing a access *panic* in
+        the system.
+        """
+        self.temp_key = str(self.options.secret_key)
+
+    def _get_temp_signature(self, method, expires, path):
+        """HP prepends '<tenant_id>:<access_key_id>:' in the signature.
+
+        Simply because "they can".
+        """
+        assert self.temp_key is not None, 'TempKey is not set'
+        body = '%s\n%s\n%s' % (method, expires, path)
+        sig = hmac.new(self.temp_key, body, hashlib.sha1).hexdigest()
+        return '{}:{}:{}'.format(
+            self.options.tenant_id, self.options.access_key_id, sig)

=== added directory 'gatekeeper/gatekeeper/datastore/tests'
=== added file 'gatekeeper/gatekeeper/datastore/tests/__init__.py'
--- gatekeeper/gatekeeper/datastore/tests/__init__.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/tests/__init__.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,17 @@
+# -*- coding: utf-8 -*-
+"""Swift datastore test suite."""
+
+
+class FakeOptions(object):
+    """Fake datastore options for tests."""
+
+    def __init__(self, **kwargs):
+        self.auth_url = kwargs.get('auth_url', 'http://auth-server.com')
+        self.username = kwargs.get('username', 'user')
+        self.password = kwargs.get('password', 'pass')
+        self.tenant = kwargs.get('tenant', 'user_proj')
+        self.region = kwargs.get('region', 'region')
+        self.api_version = kwargs.get('version', '2')
+        self.access_key_id = kwargs.get('access_key_id', 'ACC_KEY')
+        self.tenant_id = kwargs.get('tenant_id', 'TEN_ID')
+        self.secret_key = kwargs.get('secret_key', 'SEC_KEY')

=== added file 'gatekeeper/gatekeeper/datastore/tests/test_base.py'
--- gatekeeper/gatekeeper/datastore/tests/test_base.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/tests/test_base.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,35 @@
+# -*- coding: utf-8 -*-
+"""Swift datastore base tests."""
+from __future__ import unicode_literals
+
+from mock import patch
+from testtools import TestCase
+
+from gatekeeper.datastore.tests import FakeOptions
+from gatekeeper.datastore.base import BasicDataStore
+
+
+class TestBasicDataStore(TestCase):
+    """Tests basic DataStore."""
+
+    def test_instantiation_v1(self):
+        # DataStore authenticates, using the client.get_auth_1_0(), when
+        # instantiated.
+        options = FakeOptions(version='1')
+        with patch('swiftclient.client.get_auth_1_0') as mock_auth:
+            mock_auth.return_value = ('A_URL', 'A_TOKEN')
+            datastore = BasicDataStore(options)
+        mock_auth.assert_called()
+        self.assertEquals('A_URL', datastore.url)
+        self.assertEquals('A_TOKEN', datastore.token)
+
+    def test_instantiation_v2(self):
+        # DataStore authenticates, using the client.get_auth(), when
+        # instantiated.
+        options = FakeOptions()
+        with patch('swiftclient.client.get_auth') as mock_auth:
+            mock_auth.return_value = ('A_URL', 'A_TOKEN')
+            datastore = BasicDataStore(options)
+        mock_auth.assert_called()
+        self.assertEquals('A_URL', datastore.url)
+        self.assertEquals('A_TOKEN', datastore.token)

=== added file 'gatekeeper/gatekeeper/datastore/tests/test_sandbox.py'
--- gatekeeper/gatekeeper/datastore/tests/test_sandbox.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/tests/test_sandbox.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,219 @@
+# -*- coding: utf-8 -*-
+"""Swift datastore sandbox mixin tests."""
+from __future__ import unicode_literals
+
+from datetime import datetime
+from mock import patch
+from testtools import TestCase
+
+from gatekeeper.datastore.tests import FakeOptions
+from gatekeeper.datastore.sandbox import (
+    SandboxContainer,
+    SandboxObject,
+    SupervisedSandboxesMixin,
+    )
+from gatekeeper.datastore.tempurl import (
+    OSTempUrlProvider,
+    HPTempUrlProvider,
+    )
+
+
+def patch_it(context, name):
+    """Nested patcher helper."""
+    patcher = patch(name)
+    thing = patcher.start()
+    context.addCleanup(patcher.stop)
+    return thing
+
+
+class TestSandboxObject(TestCase):
+    """Tests for `SandboxObject`."""
+
+    def setUp(self):
+        # Creates a sample `SandboxObject`.
+        super(TestSandboxObject, self).setUp()
+        contents = {
+            'name': 'foo.txt',
+            'bytes': 11,
+            'content_type': 'text/plain',
+        }
+        self.object = SandboxObject(**contents)
+
+    def test_title(self):
+        # `SandboxObject` implements 'title'.
+        self.assertEquals(
+           'foo.txt (11 bytes, text/plain)' , self.object.title)
+
+
+class TestSandboxContainer(TestCase):
+    """Tests for `SandboxObject`."""
+
+    def setUp(self):
+        # Creates a sample `SandboxContainer`.
+        super(TestSandboxContainer, self).setUp()
+        contents = {
+            'name': 'sandbox-02c5fc18-ca73-11e3-88d9-001c4229f9ac',
+            'bytes': 17,
+            'count': 1,
+        }
+        self.url = 'http://fake.com/AUTH_1234'
+        self.token = '4321'
+        self.options = FakeOptions()
+        self.sandbox = SandboxContainer(
+            self.url, self.token, self.options, **contents)
+
+    def test_prefix(self):
+        # `SandboxContainer` implements 'PREFIX' class attribute.
+        self.assertEquals(
+            'sandbox-', SandboxContainer.PREFIX)
+
+    def test_representation(self):
+        # `SandboxContainer` representation.
+        self.assertEquals(
+            '02c5fc18-ca73-11e3-88d9-001c4229f9ac (17 bytes, 1 objects)',
+            unicode(self.sandbox))
+
+    def test_title(self):
+        # `SandboxContainer` implements 'title'.
+        self.assertEquals(
+            '02c5fc18-ca73-11e3-88d9-001c4229f9ac (17 bytes, 1 objects)',
+            self.sandbox.title)
+
+    def test_identifier(self):
+        # `SandboxContainer` implements 'identifier'.
+        self.assertEquals(
+            '02c5fc18-ca73-11e3-88d9-001c4229f9ac',
+            self.sandbox.identifier)
+
+    def test_age(self):
+        # `SandboxContainer` implements 'age'.
+        with patch.object(self.sandbox, '_now') as mock_now:
+            mock_now.return_value = datetime(2014,04,22,21)
+            age = self.sandbox.age
+        self.assertEquals('0:51:33.217380', str(age))
+
+    def test_objects(self):
+        # `SandboxContainer` contained objects iterator.
+        with patch('swiftclient.client.get_container') as mock_container:
+            mock_container.return_value = (
+                'ignored',
+                [{'name': 'one', 'bytes': 1, 'content_type': 'um'},
+                 {'name': 'two', 'bytes': 2, 'content_type': 'dois'}])
+            sandbox_objects = self.sandbox.objects
+
+        self.assertEquals(
+            ['one (1 bytes, um)',
+             'two (2 bytes, dois)'],
+            [o.title for o in sandbox_objects])
+
+    def test_drop(self):
+        # `SandboxContainer` drop method delete the sandbox and its contents.
+        mock_gc = patch_it(self, 'swiftclient.client.get_container')
+        mock_do = patch_it(self, 'swiftclient.client.delete_object')
+        mock_dc = patch_it(self, 'swiftclient.client.delete_container')
+        # Simulates a sandbox with a single object.
+        mock_gc.return_value = (
+            'ignored', [{'name': 'one', 'bytes': 1, 'content_type': 'um'}])
+        self.sandbox.drop()
+        # 'delete_object' is called once for the contained object.
+        mock_do.assert_called_once_with(
+            self.url, self.token, self.sandbox.name, 'one')
+        # 'delete_container' is called once for the sandbox container.
+        mock_dc.assert_called_once_with(
+            self.url, self.token, self.sandbox.name)
+
+    def test_get_tempurl_provider_os(self):
+        # `SandboxContainer` uses appropriate tempurl provider for OS.
+        self.assertIsInstance(
+            self.sandbox._get_tempurl_provider(), OSTempUrlProvider)
+
+    def test_get_tempurl_provider_hp(self):
+        # `SandboxContainer` uses appropriate tempurl provider for HP
+        hp_options = FakeOptions(
+            auth_url='http://hpcloud.com', secret_key=b'secret')
+        hp_sandbox = SandboxContainer(self.url, self.token, hp_options)
+        self.assertIsInstance(
+            hp_sandbox._get_tempurl_provider(), HPTempUrlProvider)
+
+    def test_get_temp_url(self):
+        # `SandboxContainer` wraps the tempurl provider.
+        # Constant tempurl key.
+        mock_key = patch_it(
+            self,
+            'gatekeeper.datastore.sandbox.SandboxContainer._get_tempurl_key')
+        mock_key.return_value = b'02c5fc18-ca73-11e3-88d9-001c4229f9ac'
+        # Known expiration time.
+        mock_time = patch_it(self, 'time.time')
+        mock_time.return_value = 1397702769
+        # Suppress external access.
+        mock_pa = patch_it(self, 'swiftclient.client.post_account')
+        # And finaly builds a predictable tempurl.
+        self.assertEquals(
+            'http://fake.com/v1/AUTH_1234/'
+            'sandbox-02c5fc18-ca73-11e3-88d9-001c4229f9ac/a_object?'
+            'temp_url_sig=a218db1ec606995f4912c0e3193b059926fb451d&'
+            'temp_url_expires=1397702829',
+            self.sandbox.get_temp_url('a_object'))
+
+
+class TestSupervisedSandboxesMixin(TestCase):
+    """Tests for `SupervisedSandboxesMixin`."""
+
+    def setUp(self):
+        # Creates a sample `SupervisedSandboxesMixin`.
+        super(TestSupervisedSandboxesMixin, self).setUp()
+        self.mixin = SupervisedSandboxesMixin()
+        self.mixin.url = 'http://a-url'
+        self.mixin.token = 'a-token'
+        self.mixin.options = FakeOptions()
+
+    def test_get_container_name(self):
+        # `SandboxContainer.PREFIX` is used to build container names.
+        self.assertEquals(
+            'sandbox-foo', self.mixin._get_container_name('foo'))
+
+    def test_sandboxes(self):
+        # `SupervisedSandboxesMixin` implements a sandbox iterator.
+        with patch('swiftclient.client.get_account') as mock_account:
+            mock_account.return_value = (
+                'ignored',
+                [{'name': 'one', 'bytes': 1, 'count': 1},
+                 {'name': 'two', 'bytes': 2, 'count': 2}])
+            sandboxes = self.mixin.sandboxes
+        self.assertEquals(
+            ['one (1 bytes, 1 objects)',
+             'two (2 bytes, 2 objects)'],
+            [s.title for s in sandboxes])
+
+    def test_get_sandbox(self):
+        # `SupervisedSandboxesMixin` implements a sandbox getter.
+        mock_account = patch_it(self, 'swiftclient.client.get_account')
+        mock_account.return_value = (
+            'ignored', [{'name': 'new', 'bytes': 0, 'count': 0}])
+        # Fetch an existing sandbox.
+        sandbox = self.mixin.get_sandbox('new')
+        mock_account.assert_called_once_with(
+            self.mixin.url, self.mixin.token, prefix='sandbox-new')
+        self.assertIsInstance(sandbox, SandboxContainer)
+        self.assertEquals('new', sandbox.name)
+        self.assertEquals(0, sandbox.size)
+        self.assertEquals(0, sandbox.count)
+
+    def test_create_sandbox(self):
+        # `SupervisedSandboxesMixin` implements a sandbox creator.
+        a_uuid = '02c5fc18-ca73-11e3-88d9-001c4229f9ac'
+        mock_uuid = patch_it(self, 'uuid.uuid1')
+        mock_uuid.return_value = a_uuid
+        mock_container = patch_it(self, 'swiftclient.client.put_container')
+        mock_account = patch_it(self, 'swiftclient.client.get_account')
+        container_name = self.mixin._get_container_name(a_uuid)
+        mock_account.return_value = (
+            'ignored', 
+            [{'name': container_name, 'bytes': 0, 'count': 0}])
+        # Create a new sandbox.
+        sandbox = self.mixin.create_sandbox()
+        self.assertIsInstance(sandbox, SandboxContainer)
+        self.assertEquals(container_name, sandbox.name)
+        self.assertEquals(a_uuid, sandbox.identifier)
+        self.assertEquals(0, sandbox.size)
+        self.assertEquals(0, sandbox.count)

=== added file 'gatekeeper/gatekeeper/datastore/tests/test_tempurl.py'
--- gatekeeper/gatekeeper/datastore/tests/test_tempurl.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/datastore/tests/test_tempurl.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,95 @@
+# -*- coding: utf-8 -*-
+"""Swift tempurl provider classes tests."""
+from __future__ import unicode_literals
+
+from mock import patch
+from testtools import TestCase
+
+from gatekeeper.datastore.tests import FakeOptions
+from gatekeeper.datastore.tempurl import (
+    OSTempUrlProvider,
+    HPTempUrlProvider,
+    )
+
+
+class TestOpenStackTempUrlProvider(TestCase):
+    """Tests for OpenStack tempurl provider."""
+
+    def setUp(self):
+        super(TestOpenStackTempUrlProvider, self).setUp()
+        url = 'http://os.com/AUTH_1234'
+        token = '4321'
+        options = FakeOptions()
+        self.provider = OSTempUrlProvider(url, token, options)
+
+    def test_instantiation(self):
+        # On instantiation and no tempurl can be generated.
+        self.assertIsNone(self.provider.temp_key)
+        self.assertRaises(
+            AssertionError,
+            self.provider.get_temp_url, 'testing', 'test.txt')
+
+    def test_set_temp_key(self):
+        # Setting tempurl key uses 'client.post_account' to store
+        # the given key in Swift.
+        temp_key = b'A_KEY'
+        with patch('swiftclient.client.post_account') as mock_post:
+            self.provider.set_temp_key(temp_key)
+        request_headers = {
+            'X-Account-Meta-Temp-URL-Key': temp_key,
+        }
+        mock_post.assert_called_once_with(
+            self.provider.url, self.provider.token, request_headers)
+        self.assertEquals(temp_key, self.provider.temp_key)
+
+    def test_set_temp_key_no_unicode(self):
+        # tempurl key must be string (or bytes), unicode is not accepted
+        self.assertRaises(
+            AssertionError, self.provider.set_temp_key, 'unicode')
+
+    def test_get_temp_url(self):
+        # Once the temp key is set, we can fetch tempurls for a given
+        # (container_name, object_name). Note that the tempurl contents
+        # are time-dependent (thus time is mocked).
+        self.provider.temp_key = b'A_KEY'
+        with patch('time.time') as mock_time:
+            mock_time.return_value = 1397702769
+            temp_url = self.provider.get_temp_url('testing', 'test.txt')
+        self.assertEquals(
+            'http://os.com/v1/AUTH_1234/testing/test.txt?'
+            'temp_url_sig=1b37ec3469a695a36e98c6faa2e5b2a10f06283a&'
+            'temp_url_expires=1397702829',
+            temp_url)
+
+
+class TestHPTempUrlProvider(TestCase):
+    """Tests for HP tempurl provider."""
+
+    def setUp(self):
+        super(TestHPTempUrlProvider, self).setUp()
+        url = 'http://hp.com/AUTH_1234'
+        token = '4321'
+        options = FakeOptions()
+        self.provider = HPTempUrlProvider(url, token, options)
+
+    def test_set_temp_key(self):
+        # Differently than OpenStack spec, HP cloud re-uses the
+        # a single 'secret_key' for signing tempurls.
+        # set_temp_key() ignores the given 'key'.
+        self.provider.set_temp_key(b'A_KEY')
+        self.assertEquals(
+            self.provider.options.secret_key, self.provider.temp_key)
+
+    def test_get_temp_url(self):
+        # HP decides that prepending 'tenant_id' and 'access_key_id'
+        # to the tempurl signature would be great!
+        self.provider.temp_key = self.provider.options.secret_key
+        with patch('time.time') as mock_time:
+            mock_time.return_value = 1397702769
+            temp_url = self.provider.get_temp_url('testing', 'test.txt')
+        self.assertEquals(
+            'http://hp.com/v1/AUTH_1234/testing/test.txt?'
+            'temp_url_sig=TEN_ID:ACC_KEY:30fe7f3119553deac95c6ff65a4f'
+            '071739fa822d&'
+            'temp_url_expires=1397702829',
+            temp_url)

=== added directory 'gatekeeper/gatekeeper/resources'
=== added file 'gatekeeper/gatekeeper/resources/__init__.py'
--- gatekeeper/gatekeeper/resources/__init__.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/resources/__init__.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,27 @@
+# -*- coding: utf-8 -*-
+"""Restish resources module."""
+from __future__ import unicode_literals
+
+import logging
+
+from restish import resource
+
+
+class GatekeeperResource(resource.Resource):
+    """Base Gatekeeper REST Resource.
+
+    Provides `datastore` and 'logger' acessors.
+    """
+
+    datastore_factory = None
+
+    @property
+    def datastore(self):
+        if self.datastore_factory is None:
+            raise NotImplemented(
+                'GatekeeperResource.datastore_factory is undefined!')
+        return self.datastore_factory()
+
+    @property
+    def logger(self):
+        return logging.getLogger(__name__)

=== added file 'gatekeeper/gatekeeper/resources/root.py'
--- gatekeeper/gatekeeper/resources/root.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/resources/root.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+"""Restish root resource."""
+from __future__ import unicode_literals
+
+from restish import resource
+from restish.app import RestishApp
+
+from gatekeeper.resources import GatekeeperResource
+from gatekeeper.resources.v1 import API as v1_api
+
+
+class Root(GatekeeperResource):
+    """Root REST Resource."""
+
+    @resource.child('api/v1')
+    def api(self, request, segments):
+        self.logger.debug('[api]: %s %s', request.url, str(segments))
+        return v1_api()
+
+
+def make_app(datastore_factory):
+    """Build the wsgi app object with the given datastore factory."""
+    GatekeeperResource.datastore_factory = datastore_factory
+    return RestishApp(Root())

=== added directory 'gatekeeper/gatekeeper/resources/tests'
=== added file 'gatekeeper/gatekeeper/resources/tests/__init__.py'
--- gatekeeper/gatekeeper/resources/tests/__init__.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/resources/tests/__init__.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,2 @@
+# -*- coding: utf-8 -*-
+"""Resource test suite."""

=== added file 'gatekeeper/gatekeeper/resources/tests/test_api.py'
--- gatekeeper/gatekeeper/resources/tests/test_api.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/resources/tests/test_api.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,102 @@
+# -*- coding: utf-8 -*-
+"""Restful API test suite."""
+from __future__ import unicode_literals
+
+from testtools import TestCase
+from webtest import TestApp
+
+from gatekeeper.resources.root import make_app
+
+
+class FakeObject(object):
+
+    def __init__(self, title='A_OBJ'):
+        self.title = title
+
+
+class FakeSandbox(object):
+
+    def __init__(self, identifier='A_UUID', title='A_OBJ'):
+        self.identifier = identifier
+        self.title = title
+        self.objects = [FakeObject('obj1'), FakeObject('obj2')]
+
+    def get_temp_url(self, obj_name, method):
+        return b'{}/{}/{}'.format(method, self.identifier, obj_name)
+
+    def drop(self):
+        return
+
+
+class FakeDataStore(object):
+
+    def create_sandbox(self):
+        return FakeSandbox()
+
+    def get_sandbox(self, identifier):
+        return FakeSandbox(identifier)
+
+
+def fake_datastore_factory(klass):
+    return FakeDataStore()
+
+
+class TestAPIv1(TestCase):
+
+    def setUp(self):
+        # Run the restful server.
+        super(TestAPIv1, self).setUp()
+        wsgi_app = make_app(fake_datastore_factory)
+        self.app = TestApp(wsgi_app, relative_to='.')
+
+    def test_get_greeting(self):
+        # GET on the root URL returns a greeting string as plain/text.
+        resp = self.app.get('/api/v1/')
+        self.assertEqual(200, resp.status_code)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('CI-Airline gatekeeper.\n', resp.body)
+
+    def test_post_creates_a_sandbox(self):
+        # POST on the root URL creates a new sandbox and returns
+        # status 201, 'Location' header and body (as 'text/plain')
+        # container the created sandbox path.
+        resp = self.app.post('/api/v1/')
+        self.assertEqual(201, resp.status_code)
+        self.assertEqual('/api/v1/sandbox/A_UUID', resp.location)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('/api/v1/sandbox/A_UUID', resp.body)
+
+    def test_other_methods_not_allowed(self):
+        # PUT and DELETE are not allowed.
+        self.app.put('/api/v1/', status=405)
+        self.app.delete('/api/v1/', status=405)
+
+    def test_get_sandbox_contents(self):
+        # GET on a sandbox URL lists its contents
+        resp = self.app.get('/api/v1/sandbox/A_UUID')
+        self.assertEqual(200, resp.status_code)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('obj1\nobj2', resp.body)
+
+    def test_delete_sandbox(self):
+        # DELETE on a sandbox URL deletes the sandbox and its contents.
+        resp = self.app.delete('/api/v1/sandbox/A_UUID')
+        self.assertEqual(200, resp.status_code)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('', resp.body)
+
+    def test_put_object(self):
+        # PUT on a sandbox object URL returns a tempurl for
+        # uploading it.
+        resp = self.app.put('/api/v1/sandbox/A_UUID/A_OBJ')
+        self.assertEqual(200, resp.status_code)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('PUT/A_UUID/A_OBJ', resp.body)
+
+    def test_get_object(self):
+        # GET on a sandbox object URL returns a tempurl for
+        # downloading it.
+        resp = self.app.get('/api/v1/sandbox/A_UUID/A_OBJ')
+        self.assertEqual(200, resp.status_code)
+        self.assertEqual('text/plain', resp.content_type)
+        self.assertEqual('GET/A_UUID/A_OBJ', resp.body)

=== added file 'gatekeeper/gatekeeper/resources/v1.py'
--- gatekeeper/gatekeeper/resources/v1.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/gatekeeper/resources/v1.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,87 @@
+# -*- coding: utf-8 -*-
+"""Restish v1 API."""
+from __future__ import unicode_literals
+
+from restish import (
+    http,
+    resource,
+    )
+
+from gatekeeper.resources import GatekeeperResource
+
+
+class SandboxAPI(GatekeeperResource):
+    """Sandbox API
+
+    - GET '' -> list sandbox objects
+    - DELETE '' -> delete sandbox and its contents
+    - GET '{object_name}' -> returns a tempurl for downloading the object
+    - PUT '{object_name}' -> returns a tempurl for uploading the object
+    """
+
+    def __init__(self, identifier):
+        super(SandboxAPI, self).__init__()
+        self.identifier = identifier
+
+    def _render_response(self, payload):
+        headers = [
+            (b'Content-Type', b'text/plain')
+        ]
+        return http.ok(headers, str(payload))
+
+    @resource.GET()
+    def contents(self, request):
+        sandbox = self.datastore.get_sandbox(self.identifier)
+        objects = [o.title for o in sandbox.objects]
+        return self._render_response('\n'.join(objects))
+
+    @resource.DELETE()
+    def drop(self, request):
+        sandbox = self.datastore.get_sandbox(self.identifier)
+        sandbox.drop()
+        self.logger.info(
+            'Sandbox {} deleted.'.format(sandbox.identifier))
+        return self._render_response('')
+
+    def _get_temp_url(self, object_name, method):
+        sandbox = self.datastore.get_sandbox(self.identifier)
+        temp_url = sandbox.get_temp_url(object_name, method)
+        return self._render_response(temp_url)
+
+    @resource.child('{object_name}')
+    def object_wrapper(self, request, segments, object_name):
+        allow = ['GET', 'PUT']
+        if request.method not in allow:
+            return http.method_not_allowed(allow)
+        return self._get_temp_url(object_name, request.method)
+
+
+class API(GatekeeperResource):
+    """Base Sandbox API provider.
+
+    - GET '' -> greeting message
+    - POST '' -> creates a sandbox
+    - 'sandbox/{identifier}' -> traverse to `SandboxAPI`
+    """
+
+    PATH = '/api/v1'
+    GREETINGS = b'CI-Airline gatekeeper.\n'
+
+    @resource.child('')
+    def root(self, request, segments):
+        allow = ['GET', 'POST']
+        if request.method not in allow:
+            return http.method_not_allowed(allow)
+        headers = [
+            (b'Content-Type', b'text/plain'),
+        ]
+        if request.method == 'GET':
+            return http.ok(headers, self.GREETINGS)
+        sandbox = self.datastore.create_sandbox()
+        location = b'{}/sandbox/{}'.format(self.PATH, sandbox.identifier)
+        self.logger.info('Sandbox {} created.'.format(location))
+        return http.created(location, headers, location)
+
+    @resource.child('sandbox/{sandbox_identifier}')
+    def object_wrapper(self, request, segments, sandbox_identifier):
+        return SandboxAPI(sandbox_identifier)

=== added file 'gatekeeper/requirements.txt'
--- gatekeeper/requirements.txt	1970-01-01 00:00:00 +0000
+++ gatekeeper/requirements.txt	2014-04-25 12:34:29 +0000
@@ -0,0 +1,7 @@
+httplib2==0.9
+mock==1.0.1
+python-keystoneclient==0.7.1
+python-swiftclient==2.0.3
+restish==0.12.1
+testtools==0.9.35
+WebTest==2.0.10

=== added file 'gatekeeper/sandbox.py'
--- gatekeeper/sandbox.py	1970-01-01 00:00:00 +0000
+++ gatekeeper/sandbox.py	2014-04-25 12:34:29 +0000
@@ -0,0 +1,104 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+"""Swift tempurl manager"""
+from __future__ import unicode_literals
+
+import httplib2
+import logging
+from optparse import (
+    OptionParser,
+    make_option,
+    )
+import os
+import sys
+import uuid
+
+from gatekeeper.datastore import DataStore
+
+
+option_usage = "usage: %prog [options] [args]"
+option_list = [
+    make_option("-v", "--verbose",
+                action="store_true", dest="verbose"),
+    make_option("-A", "--auth-url",
+                default=os.environ.get('OS_AUTH_URL'), dest="auth_url"),
+    make_option("-U", "--username",
+                default=os.environ.get('OS_USERNAME'), dest="username"),
+    make_option("-K", "--key",
+                default=os.environ.get('OS_PASSWORD'), dest="password"),
+    make_option("-T", "--tenant",
+                default=os.environ.get('OS_TENANT_NAME'), dest="tenant"),
+    make_option("-R", "--region",
+                default=os.environ.get('OS_REGION_NAME'), dest="region"),
+    make_option("-V", "--api-version",
+                default='2', dest="api_version"),
+    make_option("--hp-tenant-id",
+                default='', dest="tenant_id"),
+    make_option("--hp-access-key-id",
+                default='', dest="access_key_id"),
+    make_option("--hp-secret-key",
+                default='', dest="secret_key"),
+    ]
+
+
+def main():
+    parser = OptionParser(usage=option_usage, option_list=option_list)
+    (options, args) = parser.parse_args()
+
+    logger = logging.getLogger("swiftclient")
+    if options.verbose:
+        level = logging.DEBUG
+    else:
+        level = logging.ERROR
+    logging.basicConfig(level=level)
+
+    if options.auth_url and 'hpcloud' in options.auth_url:
+        if not (options.tenant_id and options.access_key_id
+                and options.secret_key):
+            sys.stdout.write('For HP, all --hp-* options are required!\n')
+            sys.exit(1)
+
+    ds = DataStore(options)
+
+    if len(args) == 0:
+        sys.stdout.write('Select an action!\n')
+        sys.exit(1)
+
+    if args[0] == 'list' and len(args) == 1:
+        sys.stdout.write('All Sandboxes:\n')
+        for sandbox in ds.sandboxes:
+            sys.stdout.write('\t{}\n'.format(sandbox.title))
+    elif args[0] == 'list' and len(args) == 2:
+        sandbox = ds.get_sandbox(args[1])
+        sys.stdout.write('{}\n'.format(sandbox.title))
+        for obj in sandbox.objects:
+            sys.stdout.write('\t{}\n'.format(obj.title))
+    elif args[0] == 'create' and len(args) == 1:
+        sandbox = ds.create_sandbox()
+        sys.stdout.write('Sandbox created: {}\n'.format(sandbox.identifier))
+    elif args[0] == 'drop' and len(args) == 2:
+        sandbox = ds.get_sandbox(args[1])
+        sandbox.drop()
+        sys.stdout.write('Sandbox dropped: {}\n'.format(sandbox.identifier))
+    elif args[0] == 'upload' and len(args) == 3:
+        sandbox = ds.get_sandbox(args[1])
+        temp_url = sandbox.get_temp_url(args[2], method='PUT')
+        sys.stdout.write('Uploading to {}\n'.format(temp_url))
+        response, content = httplib2.Http().request(
+            temp_url, "PUT", body=open(args[2]).read())
+        assert response.status == 201, 'Failed {}'.format(response.status)
+    elif args[0] == 'download' and len(args) == 3:
+        sandbox = ds.get_sandbox(args[1])
+        temp_url = sandbox.get_temp_url(args[2], method='GET')
+        sys.stdout.write('Downloading from {}\n'.format(temp_url))
+        response, content = httplib2.Http().request(temp_url)
+        assert response.status == 200, 'Failed {}'.format(response.status)
+        open(args[2], 'wb').write(content)
+    else:
+        sys.stdout.write(
+            'Unsupported action: {}\n'.format(' '.join(args)))
+        sys.exit(1)
+
+
+if __name__ == '__main__':
+    main()

=== added file 'gatekeeper/setup-swift.sh'
--- gatekeeper/setup-swift.sh	1970-01-01 00:00:00 +0000
+++ gatekeeper/setup-swift.sh	2014-04-25 12:34:29 +0000
@@ -0,0 +1,76 @@
+#!/bin/sh
+# Set up a totally insecure swift instance. This is meant to be run in a
+# freshly created Ubuntu container or VM, for locally testing software that
+# talks to swift.
+# Author: Martin Pitt <martin.pitt@ubuntu.com>
+# Author: Celso Providelo <celso.providelo@canonical.com>
+set -e
+
+DIR=/srv/swift
+
+[ `id -u` = 0 ] || {
+    echo "You need to run this script as root" >&2
+    exit 1
+}
+
+apt-get install -y python-swiftclient memcached swift swift-account swift-container swift-object swift-proxy
+mkdir -p $DIR/1
+chown -R swift:swift $DIR
+
+cd /etc/swift
+cat <<EOF | tee proxy-server.conf
+[DEFAULT]
+bind_port = 8080
+log_facility = LOG_LOCAL1
+
+[pipeline:main]
+pipeline = healthcheck cache tempauth proxy-server
+
+[app:proxy-server]
+use = egg:swift#proxy
+allow_account_management = true
+account_autocreate = true
+
+[filter:tempauth]
+use = egg:swift#tempauth
+user_admin_admin = admin .admin .reseller_admin
+user_testproj_testuser = testpwd .admin
+
+[filter:healthcheck]
+use = egg:swift#healthcheck
+
+[filter:cache]
+use = egg:swift#memcache
+
+[filter:tempurl]
+use = egg:swift#tempurl
+EOF
+
+cat <<EOF | tee swift.conf
+[swift-hash]
+swift_hash_path_suffix = mystuff
+EOF
+
+# https://launchpad.net/bugs/1290813
+/bin/echo -e '\n[container-sync]' >> container-server.conf
+
+# add devices and ports to configuration and create rings
+for i in "object 6010" "account 6020" "container 6030"; do
+    what=${i% *}
+    port=${i#* }
+    sed -i "/\[DEFAULT\]/ a devices = $DIR\nmount_check = false\nbind_port = $port" ${what}-server.conf
+
+   swift-ring-builder ${what}.builder create 18 3 1
+   swift-ring-builder ${what}.builder add z1-127.0.0.1:$port/1 1
+   swift-ring-builder ${what}.builder rebalance
+done
+
+# exits with 1 even if everything succeeded
+swift-init restart all || true
+
+# create user account
+cat <<EOF
+Now check that it works with
+
+    swift -A http://127.0.0.1:8080/auth/v1.0 -U testproj:testuser -K testpwd stat -v
+EOF

